# -*- coding: utf-8 -*-

"""
postnlecommerceapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from postnlecommerceapis.api_helper import APIHelper
from postnlecommerceapis.configuration import Server
from postnlecommerceapis.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from postnlecommerceapis.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from postnlecommerceapis.models.cpc_response import CpcResponse
from postnlecommerceapis.exceptions.cpc_response_invalid_exception import CpcResponseInvalidException
from postnlecommerceapis.exceptions.checkout_postal_codecheck_unauthorized_exception import CheckoutPostalCodecheckUnauthorizedException
from postnlecommerceapis.exceptions.checkout_postal_codecheck_method_not_allowed_exception import CheckoutPostalCodecheckMethodNotAllowedException
from postnlecommerceapis.exceptions.checkout_postal_codecheck_too_many_request_exception import CheckoutPostalCodecheckTooManyRequestException
from postnlecommerceapis.exceptions.cpc_response_error_exception import CpcResponseErrorException


class PostalcodeCheckController(BaseController):

    """A Controller to access Endpoints in the postnlecommerceapis API."""
    def __init__(self, config):
        super(PostalcodeCheckController, self).__init__(config)

    def checkout_postalcode_check(self,
                                  postalcode,
                                  housenumber,
                                  housenumberaddition=None):
        """Does a GET request to /shipment/checkout/v1/postalcodecheck.

        Please note that this API is not available on the sandbox
        environment.
        Request example:
        ```
        curl -X GET
        "https://api.postnl.nl/shipment/checkout/v1/postalcodecheck?postalcode=
        3571ZZ&amp;housenumber=74&amp;housenumberaddition=bis" \
         -H "Accept: application/json" \
         -H "apikey: APIKEY-HERE" 
        ```

        Args:
            postalcode (str): TODO: type description here.
            housenumber (int): TODO: type description here.
            housenumberaddition (str, optional): TODO: type description here.

        Returns:
            List[CpcResponse]: Response from the API. Success

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/shipment/checkout/v1/postalcodecheck')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('postalcode')
                         .value(postalcode))
            .query_param(Parameter()
                         .key('housenumber')
                         .value(housenumber))
            .query_param(Parameter()
                         .key('housenumberaddition')
                         .value(housenumberaddition))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(CpcResponse.from_dictionary)
            .local_error('400', 'Bad request', CpcResponseInvalidException)
            .local_error('401', 'Invalid apikey', CheckoutPostalCodecheckUnauthorizedException)
            .local_error('405', 'Method not allowed', CheckoutPostalCodecheckMethodNotAllowedException)
            .local_error('429', 'Too many requests', CheckoutPostalCodecheckTooManyRequestException)
            .local_error('500', 'Internal server error', CpcResponseErrorException)
        ).execute()
